//+------------------------------------------------------------------+
//|                                                    Govorilka.mq4 |
//|                                                                * |
//|                                                                * |
//+------------------------------------------------------------------+
#property copyright "Integer"
#property link      "for-good-letters@yandex.ru"

#import "kernel32.dll"
   int WinExec(string,int);
#import


//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
//----
     
     fSay(aChartText(Symbol(),Period(),2),2);

//----
   return(0);
  }
//+------------------------------------------------------------------+

string aChartText(string aSymbol,string aTimeFrame,int aMode=2){ // Mode: 1 -  , 2 -    ;)
   return(fSimbolText(aSymbol,aMode)+", "+fTFText(aTimeFrame));
}

string fTFText(int aTimeFrame){
   if(aTimeFrame==0){
      aTimeFrame=Period();
   }
   switch(aTimeFrame){
      case 1:
         return(" 1");
      case 5:
         return(" 5");                  
      case 15:
         return(" 15");
      case 30:
         return(" 30");             
      case 60:
         return(" 1");
      case 240:
         return(" 4");                  
      case 1440:
         return(" 1");
      case 10080:
         return(" 1");          
      case 43200:
         return("\' 1");
      default:
         return(" "+aTimeFrame);          
   }
}

string fSimbolText(string aSymbol,int aMode=2){
   aSymbol=fStrDeleteLowerCase(aSymbol);
      if(StringLen(aSymbol)==6){
         string tVList[]={  
         "AUD"," "," ","ATS"," ","  ","BEF"," ","",
         "GBP"," ","  \'","CAD"," ","","CZK"," ","  ",
         "DKK"," ","  ","NLG","","  ","EEK"," ","  ",
         "EUR","  ","","FIM"," ","","FRF"," ","  ",
         "DEM"," ","","GRD"," ","  ","HKD"," ","  ",
         "HUF"," ","","IEP"," ","  ","ITL"," ","  ",
         "JPY"," ","  ","LVL"," ","  ","LTL"," ","  ",
         "MXN"," ","  ","NZD"," ","  ","NOK"," ","",
         "PLN"," ","  ",""," ","  ","RUB"," ","\'",
         "RUR"," ","\'",   "SGD"," ","  ","SKK"," ","  ",
         "ZAR"," ","","ESP"," ","  ","SEK"," ","",
         "CHF"," "," ","UAH"," ","\'","USD"," ","  "};
         string tLVal=StringSubstr(aSymbol,0,3);
         string tRVal=StringSubstr(aSymbol,3,3);  
         int tLIndex=-1;
         int tRIndex=-1;                  
            for(int ti=0;ti<ArraySize(tVList);ti+=3){
               if(tLVal==tVList[ti]){
               
                 tLIndex=ti;
                     for(int tj=ti+3;tj<ArraySize(tVList);tj+=3){
                        if(tRVal==tVList[tj]){
                           tRIndex=tj;                           
                           break;
                        }
                     }
                  break;
               }
               if(tRVal==tVList[ti]){
                  tRIndex=ti;
                     for(tj=ti+3;tj<ArraySize(tVList);tj+=3){
                        if(tLVal==tVList[tj]){
                           tLIndex=tj;
                           break;
                        }
                     }   
                  break;            
               }               
            }
            if(tLIndex>=0){
               if(tRIndex>=0){
                  return(tVList[tLIndex+aMode]+" "+tVList[tRIndex+aMode]);
               }
            }
      }
   string tList2[]={"GOLD","","","SILVER","","\'"};
      for(ti=0;ti<ArraySize(tList2);ti++){
         if(aSymbol==tList2[ti]){
            return(tList2[ti+aMode]);
         }
      }
   aSymbol=fStrLowerCase(aSymbol);
   aSymbol=fStrDeleteUpperCase(aSymbol);
   string tRet="";      
      for(ti=0;ti<StringLen(aSymbol);ti++){
         tRet=tRet+StringSubstr(aSymbol,ti,1)+" ";
      }
      if(tRet==""){
         return(" ");
      }
   return(tRet);
}

string fStrLowerCase(string aString){
      for(int i=0;i<StringLen(aString);i++){
         int char=StringGetChar(aString,i);
            if(char>64){
               if(char<91){
                  aString=StringSetChar(aString,i,char+32);
                  continue;
               }      
            }
            if(char>191){
               if(char<224){
                  aString=StringSetChar(aString,i,char+32);
                  continue;
               }
            }
            if(char==168){
               aString=StringSetChar(aString,i,184);
               continue;
            }               
      }
   return(aString);
}

string fStrDeleteUpperCase(string aString){
   string tSring="";
      for(int ti=0;ti<StringLen(aString);ti++){
         string tChar=StringSubstr(aString,ti,1);
            if(tChar!=fStrUpperCase(tChar)){
               tSring=tSring+tChar;
            }
      }
   return(tSring);      
}

string fStrDeleteLowerCase(string aString){
   string tSring="";
      for(int ti=0;ti<StringLen(aString);ti++){
         string tChar=StringSubstr(aString,ti,1);
            if(tChar==fStrUpperCase(tChar)){
               tSring=tSring+tChar;
            }
      }
   return(tSring);      
}

string fStrUpperCase(string aString){
      for(int i=0;i<StringLen(aString);i++){
         int char=StringGetChar(aString,i);
            if(char>96){
               if(char<123){
                  aString=StringSetChar(aString,i,char-32);
                  continue;
               }  
            }    
            if(char>223){
               if(char<256){
                  aString=StringSetChar(aString,i,char-32);
                  continue;
               }
            }
            if(char==184){
               aString=StringSetChar(aString,i,168);
               continue;
            }               
      }
   return(aString);
}


void fSay(string aText,int aVoice=0){
   string tVoce="";
      switch (aVoice){
         case 0:
            tVoce="Adult Male #1 Russian (L&H)";
         break;      
         case 1:
            tVoce="Adult Female #1 Russian (L&H)";      
         break;
         case 2:
            tVoce="Digalo Russian Nicolai";      
         break;         
      }   
   WinExec("c:/Govorilka_cp.exe -E \""+tVoce+"\" \""+aText+"\"",1);
}